Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Java™ Platform Standard Ed. 6
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.lang.management
Class ManagementFactory

    java.lang.Object
      java.lang.management.ManagementFactory

    public class ManagementFactory

extends Object

The `ManagementFactory` class is a factory class for getting managed beans for the Java platform. This class consists of static methods each of which returns one or more platform MXBean(s) representing the management interface of a component of the Java virtual machine.

An application can access a platform MXBean in the following ways:

- Direct access to an MXBean interface
  1. Get the MXBean instance through the static factory method and access the MXBean locally of the running virtual machine.
  2. Construct an MXBean proxy instance that forwards the method calls to a given `MBeanServer` by calling `newPlatfromMXBeanProxy`. A proxy is typically constructed to remotely access an MXBean of another running virtual machine.
- Indirect access to an MXBean interface via MBeanServer
  1. Go through the `platform MBeanServer` to access MXBeans locally or a specific `MBeanServerConnection` to access MXBeans remotely. The attributes and operations of an MXBean use only JMX open types which include basic data types, `CompositeData`, and `TabularData` defined in `OpenType`. The mapping is specified below.

#### Platform MXBeans

A platform MXBean is a managed bean that conforms to the JMX Instrumentation Specification and only uses a set of basic data types described below. See the specification of MXBeans for details. A JMX management application and the platform `MBeanServer` can interoperate without requiring classes for MXBean specific data types. The data types being transmitted between the JMX connector server and the connector client are open types and this allows interoperation across versions.

The platform MXBean interfaces use only the following data types:

- Primitive types such as `int`, `long`, `boolean`, etc
- Wrapper classes for primitive types such as `Integer`, `Long`, `Boolean`, etc and `String`
- `Enum` classes
- Classes that define only getter methods and define a static `from` method with a `CompositeData` argument to convert from an input `CompositeData` to an instance of that class
- `List<E>` where `E` is a primitive type, a wrapper class, an enum class, or a class supporting conversion from a `CompositeData` to its class
- `Map<K,V>` where `K` and `V` are a primitive type, a wrapper class, an enum class, or a class supporting conversion from a `CompositeData` to its class

When an attribute or operation of a platform MXBean is accessed via an `MBeanServer`, the data types are mapped as follows:

- A primitive type or a wrapper class is mapped to the same type.
- An `Enum` is mapped to `String` whose value is the name of the enum constant.
- A class that defines only getter methods and a static `from` method with a `CompositeData` argument is mapped to `CompositeData`.
- `Map<K,V>` is mapped to `TabularData` whose row type is a `CompositeType` with two items whose names are "key" and "value" and the item types are the corresponding mapped type of `K` and `V` respectively and the "key" is the index.
- `List<E>` is mapped to an array with the mapped type of `E` as the element type.
- An array of element type `E` is mapped to an array of the same dimenions with the mapped type of `E` as the element type.

The `MBeanInfo` for a platform MXBean describes the data types of the attributes and operations as primitive or open types mapped as specified above.

For example, the `MemoryMXBean` interface has the following getter and setter methods:

>      public MemoryUsage getHeapMemoryUsage();
>      public boolean isVerbose();
>      public void setVerbose(boolean value);

These attributes in the `MBeanInfo` of the `MemoryMXBean` have the following names and types:

> Attribute Name | Type
> --- | ---
> `HeapMemoryUsage` | `CompositeData representing MemoryUsage`
> `Verbose` | `boolean`

#### MXBean Names

Each platform MXBean for a Java virtual machine has a unique `ObjectName` for registration in the platform `MBeanServer`. A Java virtual machine has a single instance of the following management interfaces:

> Management Interface | ObjectName
> --- | ---
> `ClassLoadingMXBean` | ``java.lang:type=ClassLoading``
> `MemoryMXBean` | ``java.lang:type=Memory``
> `ThreadMXBean` | ``java.lang:type=Threading``
> `RuntimeMXBean` | ``java.lang:type=Runtime``
> `OperatingSystemMXBean` | ``java.lang:type=OperatingSystem``

A Java virtual machine has zero or a single instance of the following management interfaces.

> Management Interface | ObjectName
> --- | ---
> `CompilationMXBean` | ``java.lang:type=Compilation``

A Java virtual machine may have one or more instances of the following management interfaces.

> Management Interface | ObjectName
> --- | ---
> `GarbageCollectorMXBean` | ``java.lang:type=GarbageCollector```,name=`collector's name
> `MemoryManagerMXBean` | ``java.lang:type=MemoryManager```,name=`manager's name
> `MemoryPoolMXBean` | ``java.lang:type=MemoryPool```,name=`pool's name

Since:
  1.5
See Also:
  JMX Specification., Ways to Access Management Metrics, `LoggingMXBean`, `MXBean`

Field Summary
`static String` | `CLASS_LOADING_MXBEAN_NAME` String representation of the `ObjectName` for the `ClassLoadingMXBean`.
`static String` | `COMPILATION_MXBEAN_NAME` String representation of the `ObjectName` for the `CompilationMXBean`.
`static String` | `GARBAGE_COLLECTOR_MXBEAN_DOMAIN_TYPE` The domain name and the type key property in the `ObjectName` for a `GarbageCollectorMXBean`.
`static String` | `MEMORY_MANAGER_MXBEAN_DOMAIN_TYPE` The domain name and the type key property in the `ObjectName` for a `MemoryManagerMXBean`.
`static String` | `MEMORY_MXBEAN_NAME` String representation of the `ObjectName` for the `MemoryMXBean`.
`static String` | `MEMORY_POOL_MXBEAN_DOMAIN_TYPE` The domain name and the type key property in the `ObjectName` for a `MemoryPoolMXBean`.
`static String` | `OPERATING_SYSTEM_MXBEAN_NAME` String representation of the `ObjectName` for the `OperatingSystemMXBean`.
`static String` | `RUNTIME_MXBEAN_NAME` String representation of the `ObjectName` for the `RuntimeMXBean`.
`static String` | `THREAD_MXBEAN_NAME` String representation of the `ObjectName` for the `ThreadMXBean`.

Method Summary
`static ClassLoadingMXBean` | `getClassLoadingMXBean()` Returns the managed bean for the class loading system of the Java virtual machine.
`static CompilationMXBean` | `getCompilationMXBean()` Returns the managed bean for the compilation system of the Java virtual machine.
`static List<GarbageCollectorMXBean>` | `getGarbageCollectorMXBeans()` Returns a list of `GarbageCollectorMXBean` objects in the Java virtual machine.
`static List<MemoryManagerMXBean>` | `getMemoryManagerMXBeans()` Returns a list of `MemoryManagerMXBean` objects in the Java virtual machine.
`static MemoryMXBean` | `getMemoryMXBean()` Returns the managed bean for the memory system of the Java virtual machine.
`static List<MemoryPoolMXBean>` | `getMemoryPoolMXBeans()` Returns a list of `MemoryPoolMXBean` objects in the Java virtual machine.
`static OperatingSystemMXBean` | `getOperatingSystemMXBean()` Returns the managed bean for the operating system on which the Java virtual machine is running.
`static MBeanServer` | `getPlatformMBeanServer()` Returns the platform `MBeanServer`.
`static RuntimeMXBean` | `getRuntimeMXBean()` Returns the managed bean for the runtime system of the Java virtual machine.
`static ThreadMXBean` | `getThreadMXBean()` Returns the managed bean for the thread system of the Java virtual machine.
`static
`<T> T`
` | `newPlatformMXBeanProxy(MBeanServerConnection connection, String mxbeanName, Class<T> mxbeanInterface)` Returns a proxy for a platform MXBean interface of a given MXBean name that forwards its method calls through the given `MBeanServerConnection`.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### CLASS_LOADING_MXBEAN_NAME

    public static final String CLASS_LOADING_MXBEAN_NAME

  String representation of the `ObjectName` for the `ClassLoadingMXBean`.

  See Also:
    Constant Field Values

### COMPILATION_MXBEAN_NAME

    public static final String COMPILATION_MXBEAN_NAME

  String representation of the `ObjectName` for the `CompilationMXBean`.

  See Also:
    Constant Field Values

### MEMORY_MXBEAN_NAME

    public static final String MEMORY_MXBEAN_NAME

  String representation of the `ObjectName` for the `MemoryMXBean`.

  See Also:
    Constant Field Values

### OPERATING_SYSTEM_MXBEAN_NAME

    public static final String OPERATING_SYSTEM_MXBEAN_NAME

  String representation of the `ObjectName` for the `OperatingSystemMXBean`.

  See Also:
    Constant Field Values

### RUNTIME_MXBEAN_NAME

    public static final String RUNTIME_MXBEAN_NAME

  String representation of the `ObjectName` for the `RuntimeMXBean`.

  See Also:
    Constant Field Values

### THREAD_MXBEAN_NAME

    public static final String THREAD_MXBEAN_NAME

  String representation of the `ObjectName` for the `ThreadMXBean`.

  See Also:
    Constant Field Values

### GARBAGE_COLLECTOR_MXBEAN_DOMAIN_TYPE

    public static final String GARBAGE_COLLECTOR_MXBEAN_DOMAIN_TYPE

  The domain name and the type key property in the `ObjectName` for a `GarbageCollectorMXBean`. The unique `ObjectName` for a `GarbageCollectorMXBean` can be formed by appending this string with "`,name=`collector's name".

  See Also:
    Constant Field Values

### MEMORY_MANAGER_MXBEAN_DOMAIN_TYPE

    public static final String MEMORY_MANAGER_MXBEAN_DOMAIN_TYPE

  The domain name and the type key property in the `ObjectName` for a `MemoryManagerMXBean`. The unique `ObjectName` for a `MemoryManagerMXBean` can be formed by appending this string with "`,name=`manager's name".

  See Also:
    Constant Field Values

### MEMORY_POOL_MXBEAN_DOMAIN_TYPE

    public static final String MEMORY_POOL_MXBEAN_DOMAIN_TYPE

  The domain name and the type key property in the `ObjectName` for a `MemoryPoolMXBean`. The unique `ObjectName` for a `MemoryPoolMXBean` can be formed by appending this string with `,name=`pool's name.

  See Also:
    Constant Field Values

Method Detail

### getClassLoadingMXBean

    public static ClassLoadingMXBean getClassLoadingMXBean()

  Returns the managed bean for the class loading system of the Java virtual machine.

  Returns:
    a `ClassLoadingMXBean` object for the Java virtual machine.

### getMemoryMXBean

    public static MemoryMXBean getMemoryMXBean()

  Returns the managed bean for the memory system of the Java virtual machine.

  Returns:
    a `MemoryMXBean` object for the Java virtual machine.

### getThreadMXBean

    public static ThreadMXBean getThreadMXBean()

  Returns the managed bean for the thread system of the Java virtual machine.

  Returns:
    a `ThreadMXBean` object for the Java virtual machine.

### getRuntimeMXBean

    public static RuntimeMXBean getRuntimeMXBean()

  Returns the managed bean for the runtime system of the Java virtual machine.

  Returns:
    a `RuntimeMXBean` object for the Java virtual machine.

### getCompilationMXBean

    public static CompilationMXBean getCompilationMXBean()

  Returns the managed bean for the compilation system of the Java virtual machine. This method returns `null` if the Java virtual machine has no compilation system.

  Returns:
    a `CompilationMXBean` object for the Java virtual machine or `null` if the Java virtual machine has no compilation system.

### getOperatingSystemMXBean

    public static OperatingSystemMXBean getOperatingSystemMXBean()

  Returns the managed bean for the operating system on which the Java virtual machine is running.

  Returns:
    an `OperatingSystemMXBean` object for the Java virtual machine.

### getMemoryPoolMXBeans

    public static List<MemoryPoolMXBean> getMemoryPoolMXBeans()

  Returns a list of `MemoryPoolMXBean` objects in the Java virtual machine. The Java virtual machine can have one or more memory pools. It may add or remove memory pools during execution.

  Returns:
    a list of `MemoryPoolMXBean` objects.

### getMemoryManagerMXBeans

    public static List<MemoryManagerMXBean> getMemoryManagerMXBeans()

  Returns a list of `MemoryManagerMXBean` objects in the Java virtual machine. The Java virtual machine can have one or more memory managers. It may add or remove memory managers during execution.

  Returns:
    a list of `MemoryManagerMXBean` objects.

### getGarbageCollectorMXBeans

    public static List<GarbageCollectorMXBean> getGarbageCollectorMXBeans()

  Returns a list of `GarbageCollectorMXBean` objects in the Java virtual machine. The Java virtual machine may have one or more `GarbageCollectorMXBean` objects. It may add or remove `GarbageCollectorMXBean` during execution.

  Returns:
    a list of `GarbageCollectorMXBean` objects.

### getPlatformMBeanServer

    public static MBeanServer getPlatformMBeanServer()

  Returns the platform `MBeanServer`. On the first call to this method, it first creates the platform `MBeanServer` by calling the `MBeanServerFactory.createMBeanServer` method and registers the platform MXBeans in this platform `MBeanServer` using the MXBean names defined in the class description. This method, in subsequent calls, will simply return the initially created platform `MBeanServer`.

  MXBeans that get created and destroyed dynamically, for example, memory `pools` and `managers`, will automatically be registered and deregistered into the platform `MBeanServer`.

  If the system property `javax.management.builder.initial` is set, the platform `MBeanServer` creation will be done by the specified `MBeanServerBuilder`.

  It is recommended that this platform MBeanServer also be used to register other application managed beans besides the platform MXBeans. This will allow all MBeans to be published through the same `MBeanServer` and hence allow for easier network publishing and discovery. Name conflicts with the platform MXBeans should be avoided.

  Returns:
    the platform `MBeanServer`; the platform MXBeans are registered into the platform `MBeanServer` at the first time this method is called.
  Throws:
    `SecurityException` - if there is a security manager and the caller does not have the permission required by `MBeanServerFactory.createMBeanServer()`.
  See Also:
    `MBeanServerFactory`, `MBeanServerFactory.createMBeanServer()`

### newPlatformMXBeanProxy

    public static <T> T newPlatformMXBeanProxy(MBeanServerConnection connection,
                                               String mxbeanName,
                                               Class<T> mxbeanInterface)
                                    throws IOException

  Returns a proxy for a platform MXBean interface of a given MXBean name that forwards its method calls through the given `MBeanServerConnection`.

  This method is equivalent to:

  > `Proxy.newProxyInstance``(mxbeanInterface.getClassLoader(), new Class[] { mxbeanInterface }, handler)`

  where `handler` is an `InvocationHandler` to which method invocations to the MXBean interface are dispatched. This `handler` converts an input parameter from an MXBean data type to its mapped open type before forwarding to the `MBeanServer` and converts a return value from an MXBean method call through the `MBeanServer` from an open type to the corresponding return type declared in the MXBean interface.

  If the MXBean is a notification emitter (i.e., it implements `NotificationEmitter`), both the `mxbeanInterface` and `NotificationEmitter` will be implemented by this proxy.

  Notes:

  1. Using an MXBean proxy is a convenience remote access to a platform MXBean of a running virtual machine. All method calls to the MXBean proxy are forwarded to an `MBeanServerConnection` where `IOException` may be thrown when the communication problem occurs with the connector server. An application remotely accesses the platform MXBeans using proxy should prepare to catch `IOException` as if accessing with the `MBeanServerConnector` interface.
  2. When a client application is designed to remotely access MXBeans for a running virtual machine whose version is different than the version on which the application is running, it should prepare to catch `InvalidObjectException` which is thrown when an MXBean proxy receives a name of an enum constant which is missing in the enum class loaded in the client application.
  3. `MBeanServerInvocationHandler` or its `newProxyInstance` method cannot be used to create a proxy for a platform MXBean. The proxy object created by `MBeanServerInvocationHandler` does not handle the properties of the platform MXBeans described in the class specification.

  Parameters:
    `connection` - the `MBeanServerConnection` to forward to.
    `mxbeanName` - the name of a platform MXBean within `connection` to forward to. `mxbeanName` must be in the format of `ObjectName`.
    `mxbeanInterface` - the MXBean interface to be implemented by the proxy.
  Throws:
    `IllegalArgumentException` - if
    - `mxbeanName` is not with a valid `ObjectName` format, or
    - the named MXBean in the `connection` is not a MXBean provided by the platform, or
    - the named MXBean is not registered in the `MBeanServerConnection`, or
    - the named MXBean is not an instance of the given `mxbeanInterface`
    `IOException` - if a communication problem occurred when accessing the `MBeanServerConnection`.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Java™ Platform Standard Ed. 6
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Copyright 2009 Sun Microsystems, Inc. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.